V2EX = way to explore
V2EX 是一个关于分享和探索的地方
现在注册
已注册用户请  登录
Distributions
Ubuntu
Fedora
CentOS
中文资源站
网易开源镜像站
froz
V2EX  ›  Linux

Debian 和 Flatpak 软件源如何配合使用

  •  
  •   froz · 205 天前 · 1656 次点击
    这是一个创建于 205 天前的主题,其中的信息可能已经有所发展或是发生改变。

    大家中秋快乐~

    最近想把自己的主力系统从 Arch 转到 Debian12 上了,但考虑到 Debian 上软件包(不考虑 PPA )的丰富度不如 AUR ,打算使用 Flatpak 作为弥补。

    想问一下大家,Debian 上面软件包安装优先级是怎样的?

    比如,是优先全部用 Flatpak ;还是 Debian 自身软件源没有的,才去安装 Flatpak 上的应用?

    谢谢大家~

    14 条回复    2023-09-30 23:42:23 +08:00
    raysonx
        1
    raysonx  
       205 天前
    以个人习惯来说,源里面有的优先用源中的,源里面没有的(或者源里的版本太老旧的)或者闭源软件才会用 flatpak 里的
    shijingshijing
        2
    shijingshijing  
       205 天前
    优先 apt 源里面的,这些都是经过几轮测试了的。源里面没有的考虑 AppImage ,然后去官网或者 github 看看有没有二进制发布,最后考虑自己 make install 。
    longbow0
        3
    longbow0  
       205 天前
    日常用 debian stable ,优先使用 debian 源,除了 main, contrib, non-free, non-free-firmware 之外,加上 backports 和 fasttrack ,基本上可以满足大多数需求。

    源里没有的,再尝试 flatpak, conda 等方法
    terence4444
        4
    terence4444  
       205 天前 via iPhone
    我一般优先选 flatpak ,因为源里的通常落后好几个版本。
    froz
        5
    froz  
    OP
       205 天前
    @raysonx 有什么具体的理由吗?我曾经看到有人建议全盘用 Flatpak ,Flatpak 里没有的,才去源里面搜。他的理由是尽量沙盒化。
    raysonx
        6
    raysonx  
       205 天前   ❤️ 1
    @froz 对于开源软件来讲,我并不担心沙盒的问题。优先使用源里的主要有以下考虑:
    1. flatpak 这类打包的软件通常包含所有依赖,体积比较大,国内下载速度比较慢。
    2. 有时候因为沙盒的存在会遇到一些莫名其妙的问题,比如某个权限没有声明(打包者的问题),或者有时需要访问整个文件系统。
    froz
        7
    froz  
    OP
       205 天前
    @longbow0 谢谢,我暂时也是这样做的。大家似乎都只是把 flatpak 当作最后的备选项
    froz
        8
    froz  
    OP
       205 天前
    @raysonx 谢谢,明白您的意思了
    froz
        9
    froz  
    OP
       205 天前
    @shijingshijing 相比零散地安装二进制软件,flatpak 至少能统一管理升级,也挺好用的。apt 的源主要是过于老旧。不过都选择 debian stable 了,老旧一点确实也无所谓。
    Jirajine
        10
    Jirajine  
       205 天前 via Android
    装个 nix ,nix 的软件包比 arch (不包括 aur )还丰富,实在不行再装个 homebrew 。
    flatpak 和普通包不是一种东西,没有可比性。flatpak 包相当于 gui 应用的 docker ,你用 flatpak 装个 vscode 里面的终端就是容器里的 shell 。
    shijingshijing
        11
    shijingshijing  
       205 天前
    @froz 沙盒适合伺候国内流氓这种,再就是闭源软件,其实 Linux 下面一般还好。沙盒也有不便的地方,比如楼上说的 vscode 的 shell 问题,还有一个典型就是 zip 类软件,你套个沙盒真不方便操作。终究是付出与便利之间的权衡。
    pooorguy
        12
    pooorguy  
       205 天前
    GUI 应用优先用 flatpak ,最近升级中有一个 WPS 依赖项,导致 WPS 里粗体显示异常,试了下 flatpak 里面的 WPS 就没有这问题

    PS:用的 Debian-sid 版本,flatpak 里面用的固定版本要稳定一些
    pooorguy
        13
    pooorguy  
       205 天前
    @raysonx
    @froz
    @pooorguy
    还有一个就是,testing 和 sid 里面的 neovim 都还是好久前的 0.72 版本,源里一直没更新,用 flatpak 里的是 0.9 版本
    PromethiumL
        14
    PromethiumL  
       205 天前
    我想到前一阵子在 apt 装 pipewire 的 easyeffects 的时候,里面一个降噪的插件 ( RNNoise?) 因为不符合 Debian 源的(很保守的)规范,直接去掉了这个模块 ... 于是我就装了 flatpak 的 easyeffects 解决了问题用到现在。

    一个比较明显的缺点就是,如果你用的程序 GUI 五花八门的话(一会是 KDE 一会是 GTK 这种),一通操作下来会占相当一部分硬盘空间的。比如一个 3 MB 的程序可能用得到 500+MB 的 GUI 框架。我的 flatpak libs 已经占了十几个 G 了。可能只有装很多大型程序的时候才提高空间利用率。

    用一个不是十分贴切的类比就是,flatpak 就像你电脑装了一堆 python virtual envs, 3.4, 3.6, 3.7, 3.8, 3.11 blahblah (
    关于   ·   帮助文档   ·   博客   ·   API   ·   FAQ   ·   我们的愿景   ·   实用小工具   ·   1051 人在线   最高记录 6543   ·     Select Language
    创意工作者们的社区
    World is powered by solitude
    VERSION: 3.9.8.5 · 31ms · UTC 22:42 · PVG 06:42 · LAX 15:42 · JFK 18:42
    Developed with CodeLauncher
    ♥ Do have faith in what you're doing.